Bug 228286

Summary: JSF editor needs to support role attribute for component tags
Product: javaee Reporter: chaase3 <chaase3>
Component: JSF EditorAssignee: Martin Fousek <marfous>
Status: VERIFIED FIXED QA Contact: issues <issues.netbeans.org>
Priority: P3 CC:
Version: 7.4   
Target Milestone: 8.0   
Hardware: All   
OS: All   
URL: https://java.net/jira/browse/JAVASERVERFACES-2856
Whiteboard:
Issue Type: DEFECT Exception Report:
Bug Depends on: 235130    
Bug Blocks:    

Description chaase3 2013-04-05 14:17:26 UTC
In JSF 2.2 the component tags (prefix "h:") support the new "role" attribute. The API docs describe the attribute as follows:

"Per the WAI-ARIA spec and its relationship to HTML5 (Section title ARIA Role Attriubute), every HTML element may have a "role" attribute whose value must be passed through unmodified on the element on which it is declared in the final rendered markup. The attribute, if specified, must have a value that is a string literal that is, or an EL Expression that evaluates to, a set of space-separated tokens representing the various WAI-ARIA roles that the element belongs to."

Support for this tag is particularly important in tables on web pages, to support accessibility requirements. A table used for formatting purposes (h:panelGrid in JSF) must have the following attribute setting so that screen readers will not interpret it as a data table:

role="presentation"

Currently, JSF 2.2 in GlassFish 4 accepts this attribute and passes it through correctly. However, the JSF editor in NetBeans is still treating it as an invalid attribute in the development builds. This needs to be fixed in NB 7.3.1.

Thanks very much.
Comment 1 chaase3 2013-04-05 14:49:52 UTC
These are what I'm running on:

Product Version: NetBeans IDE Dev (Build 201304042355)
Java: 1.7.0_17; Java HotSpot(TM) 64-Bit Server VM 23.7-b01
Runtime: Java(TM) SE Runtime Environment 1.7.0_17-b02
System: Windows 7 version 6.1 running on amd64; Cp1252; en_US (nb)
Comment 2 Martin Fousek 2013-04-26 08:33:23 UTC
Thanks for reporting. I'm afraid that we missed deadline for JSF2.2 fixing so I'm reporting this issue against JSF's taglibraries metadata and we have to wait until they will fix it in some patch release. In other words targeting to NB7.4.
Comment 3 Martin Fousek 2013-04-26 08:50:03 UTC
Ok I created JSF related issue with all components where is 'role' attribute missing:
https://java.net/jira/browse/JAVASERVERFACES-2856
Comment 4 chaase3 2013-04-26 14:02:10 UTC
Thanks very much for filing the issue with the JSF implementation. I had not realized that it was a problem with their namespace definition.
Comment 5 Martin Fousek 2013-05-06 07:20:56 UTC
(In reply to comment #4)
> Thanks very much for filing the issue with the JSF implementation. I had not
> realized that it was a problem with their namespace definition.

No problem, you couldn't know that.
I attached patch to the JSF issue so I believe that it will be fixed in near JSF bundle and consequently in NetBeans 7.4.
Comment 6 Martin Fousek 2013-08-16 08:49:24 UTC
https://dl.dropboxusercontent.com/u/1418580/JAVASERVERFACES_SPEC_PUBLIC-1186.patch

Attached patch into the JSF issue. Now we must wait until it will be integrated by any JSF maintainer.
Comment 7 Martin Fousek 2013-10-17 10:44:11 UTC
Fixed by JSF library update where was the patch applied.

web-main #d512e0773131
Comment 8 Vladimir Riha 2013-10-29 13:55:24 UTC
Verified

Product Version: NetBeans IDE Dev (Build 201310290001)
Java: 1.7.0_45; Java HotSpot(TM) Client VM 24.45-b08
Runtime: Java(TM) SE Runtime Environment 1.7.0_45-b18
System: Linux version 3.2.0-48-generic-pae running on i386; UTF-8; en_US (nb)
By use of this website, you agree to the NetBeans Policies and Terms of Use. © 2012, Oracle Corporation and/or its affiliates. Sponsored by Oracle logo